#include <qlabel.h>
#include <qapplication.h>
#include <qpainter.h>
#include <qframe.h>
#include <qpixmap.h>
#include <math.h>
#include <stdio.h>
#include <termios.h>
#include <unistd.h>
#include <stdlib.h>
#include "sound.h"

#ifndef SOUNDVISION_H
#define SOUNDVISION_H


class EnergyFFT
{
 public:
  EnergyFFT(int frameSize);
  ~EnergyFFT();
  void calc(double * rframe);
 private:
  double * si, * co;
  int framesize;
  double * iframe;
};

class SoundVision : public QFrame
{
  Q_OBJECT
 public:
  SoundVision(int blockLength, QWidget * parent=NULL, char * name=NULL);
  ~SoundVision();
  void timerEvent(QTimerEvent *);
  void paintEvent(QPaintEvent *);
  void resizeEvent(QResizeEvent *);
 private:
  QPixmap * pm;
  char c;
  int id;
  signed short * inblock[4];
  unsigned short blockmarker;
  double * frame;
  int linecount;
  int i;
  double * average;
  int blocklength;
  EnergyFFT * fft;
  int dist,time;
};

#endif
