/*
 *  quadrec.c - record quadrophonic
 *
 *      Raw Data 
 *
 *  quadrec (quadrophonic sound recorder) by Robin Gruber <archi@robinsnest.de>
 */


#include <stdio.h>
#include <stdlib.h>
#include "../lib/soundlow.h"

#define DEFAULT_SPEED 		48000
#define BUFFERSIZE              8192
#define CHANNELS                4

int main(int argc, char *argv[])
{
    int k,l;
    signed short * data;
    signed short buffer[BUFFERSIZE];
    char name[40];
    int fd[CHANNELS];
    char * outputfilename;
    SoundCard soundcard((CHANNELS+1)/2,DEFAULT_SPEED,BUFFERSIZE);
    printf("Recording...\n");
    if (argc<2) {outputfilename="channel";}
    for (k=0; k<CHANNELS; k++) {
        sprintf(name,"%s%02d.raw",outputfilename,k);
        remove(name);
        if ((fd[k] = open(name, O_WRONLY | O_CREAT, 0644)) == -1) {
            perror(name);
            exit(1);
        }
    }
    data=(signed short*)malloc((CHANNELS+1)/2*BUFFERSIZE*2*sizeof(short));
    soundcard.go();
    while (true) {
        soundcard.read(data);
        printf("Samples read!\n");
        for (k=0; k<CHANNELS; k++) {
            for (l=0; l<BUFFERSIZE; l++) {
                buffer[l]=data[(k/2)*BUFFERSIZE*2+l*2+k%2];
            }
            write(fd[k],(void*)buffer,BUFFERSIZE*sizeof(short));
        }
    }

    return 0;
}

